@use '../../../../global/styles/utilities' as *;

@mixin digi-navigation-vertical-menu-item() {
  font-family: var(--digi--navigation-vertical-menu-item--font-family);
  font-weight: var(--digi--navigation-vertical-menu-item--font-weight);
  font-size: var(--digi--navigation-vertical-menu-item--font-size);
  background: var(--digi--navigation-vertical-menu-item--background);
  color: var(--digi--navigation-vertical-menu-item--color);
  border: none;
  padding: var(--digi--navigation-vertical-menu-item--padding);
  outline: var(--digi--navigation-vertical-menu-item--outline);
  width: var(--digi--navigation-vertical-menu-item--width);
  text-align: left;
  display: flex;
  justify-content: space-between; 
  box-sizing: border-box;
  text-decoration: none;
  overflow-wrap: anywhere;

  * {
    pointer-events: none;
  }

  &:hover {
    cursor: pointer;
  }

  &:focus-visible,
  &:hover {
    text-decoration: underline;
    --digi--navigation-vertical-menu-item--color: var(--digi--navigation-vertical-menu-item--color--hover);
    --digi--navigation-vertical-menu-item--background: var(--digi--navigation-vertical-menu-item--background--hover);
  }

  &:focus-visible {
    outline: var(--digi--navigation-vertical-menu-item--outline--focus);
    outline-offset: var(--digi--navigation-vertical-menu-item--outline--focus--offset);
  }

  &--active {
    --digi--navigation-vertical-menu-item--color: var(--digi--navigation-vertical-menu-item--color--active);
    --digi--navigation-vertical-menu-item--font-weight: var(--digi--navigation-vertical-menu-item--font-weight--active);

    &:focus-visible,
    &:hover {
      --digi--navigation-vertical-menu-item--color: var(--digi--navigation-vertical-menu-item--color--active);
    }

    .digi-navigation-vertical-menu--primary & {

      &::before {
        content: " ";
        display: block;
        position: absolute;
        width: var(--digi--navigation-vertical-menu-item--active-indicator-width);
        left: var(--digi--navigation-vertical-menu-item--active-indicator-left);
        top: 0;
        bottom: 0;
        background-color: var(--digi--navigation-vertical-menu-item--active-indicator-background-color);
        z-index: 2;
      }
      
    }

    .digi-navigation-vertical-menu--secondary & {
      --digi--navigation-vertical-menu-item--background: var(--digi--navigation-vertical-menu-item--background--active);

      &::before {
        content: " ";
        display: block;
        position: absolute;
        width: var(--digi--navigation-vertical-menu-item--active-indicator-width);
        left: 0;
        top: 0;
        bottom: 0;
        background-color: var(--digi--navigation-vertical-menu-item--active-indicator-background-color);
        z-index: 2;
      }

    }
  }

  &--expanded,
  &[aria-expanded="true"] {
    --digi--navigation-vertical-menu-item--font-weight: var(--digi--navigation-vertical-menu-item--font-weight--active);
  }

  &--toggle {
    width: calc(#{rem(24)} + #{var(--digi--padding--medium)});
    display: flex;
    align-items: stretch;
    justify-content: center;
    padding: var(--digi--navigation-vertical-menu-item--padding--toggle);
  }

  &--only-toggle {
    padding-right: 0;

    .digi-navigation-vertical-menu-item__toggle-icon {
      width: calc(#{rem(24)} + #{var(--digi--padding--medium)});
    }
  }

  &:hover {    
    &, // Button
    & + button // Link with button as next element
    {
      --digi--navigation-vertical-menu-item--toggle-icon--color: var(--digi--navigation-vertical-menu-item--toggle-icon--color--hover);
      --digi--navigation-vertical-menu-item--toggle-icon--background: var(--digi--navigation-vertical-menu-item--toggle-icon--background--hover);
    }
  }
  &[aria-expanded="true"] {
    --digi--navigation-vertical-menu-item--toggle-icon--color: var(--digi--navigation-vertical-menu-item--toggle-icon--color--active);
    --digi--navigation-vertical-menu-item--toggle-icon--background: var(--digi--navigation-vertical-menu-item--toggle-icon--background--active);

    &:hover {
      --digi--navigation-vertical-menu-item--toggle-icon--color: var(--digi--navigation-vertical-menu-item--toggle-icon--color--hover);
      --digi--navigation-vertical-menu-item--toggle-icon--background: var(--digi--navigation-vertical-menu-item--toggle-icon--background--hover);
    }

  }
}
